Page MenuHomeFreeBSD

Increasing Virtio driver TX scatter gather segments (VTNET_MIN_TX_SEGS) to support JUMBO MTU frames.
ClosedPublic

Authored by lohithbsd_gmail.com on Dec 15 2016, 5:14 AM.

Details

Summary

Currently in Virtio driver without TSO/GSO features enabled, the max scatter gather segments for the TX path can be 4, which limits the support for 9K JUMBO frames. 9K JUMBO frames results in more than 4 scatter gather segments and virtio driver fails to send the frame down to host OS. With TSO/GSO feature enabled max scatter gather segments can be 64, then 9K JUMBO frames are fine, this is making virtio driver to support JUMBO frames only with TSO/GSO. Increasing the VTNET_MIN_TX_SEGS which is the case for non TSO/GSO to 32 to support upto 64K JUMBO frames to Host.

Test Plan

Verified the 64K JUMBO frames transmission between FreeBSD guest OS and Yocto Linux Host OS.

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

lohithbsd_gmail.com retitled this revision from to Increasing Virtio driver TX scatter gather segments (VTNET_MIN_TX_SEGS) to support JUMBO MTU frames..
lohithbsd_gmail.com updated this object.
lohithbsd_gmail.com edited the test plan for this revision. (Show Details)
adrian accepted this revision.Dec 30 2016, 2:48 PM
adrian edited edge metadata.

looks good! do you need this committed?

This revision is now accepted and ready to land.Dec 30 2016, 2:48 PM
bryanv edited edge metadata.Dec 30 2016, 3:37 PM

looks good! do you need this committed?

Hi, I've got a few concerns so please hold off for now. Thanks.

looks good! do you need this committed?

Thanks a lot Adrian. I am waiting for Bryan's comments. Yes, need your help in committing.

Cheers,
Lohith

hiren edited edge metadata.Apr 20 2017, 6:44 PM

@bryanv do you have time to look at this now?

This revision was automatically updated to reflect the committed changes.